unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    sfile: TEdit;
    RadioButton2: TRadioButton;
    dir: TEdit;
    Button1: TButton;
    GroupBox2: TGroupBox;
    cmprate: TTrackBar;
    Label1: TLabel;
    crindex: TLabel;
    cexp: TCheckBox;
    srel: TCheckBox;
    cres: TCheckBox;
    Button2: TButton;
    mkbkp: TCheckBox;
    Button4: TButton;
    acl: TCheckBox;
    cmdl: TEdit;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    frc: TCheckBox;
    Label3: TLabel;
    ov_lay: TComboBox;
    Label4: TLabel;
    r86: TCheckBox;
    no_rel: TCheckBox;
    Label5: TLabel;
    coff: TCheckBox;
    Label6: TLabel;
    le: TCheckBox;
    Label7: TLabel;
    Label8: TLabel;
    cicons: TComboBox;
    function getds():boolean;
    procedure RadioButton2Click(Sender: TObject);
    procedure cmprateChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure batchpack;
    function mkcmdline(): string;
    procedure writecmd;
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure sfileChange(Sender: TObject);
    procedure dirChange(Sender: TObject);
    procedure ciconsClick(Sender: TObject);
    procedure cexpClick(Sender: TObject);
    procedure cresClick(Sender: TObject);
    procedure srelClick(Sender: TObject);
    procedure mkbkpClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure loadcfg;
    procedure frcClick(Sender: TObject);
    procedure cmdlKeyPress(Sender: TObject; var Key: Char);
    procedure r86Click(Sender: TObject);
    procedure no_relClick(Sender: TObject);
    procedure coffClick(Sender: TObject);
    procedure leClick(Sender: TObject);
    procedure ov_layChange(Sender: TObject);
    procedure ciconsChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  curdir:string;
  ap:boolean;

implementation

{$R *.dfm}

function TForm1.getds():boolean;
var s:string;
n,x:integer;
begin
s:=dir.Text;
x:=0;
for n:=1 to length(s) do if (s[n]=' ') then x:=1;
if (x=0) then getds:=false else getds:=true;
end;

procedure TForm1.batchpack;
var btc:textfile;
dr:string;
begin
if ap then exit;
dr:=dir.text;
writecmd;
if (dr[2]<>':') then begin showmessage('   !'); exit; end;
chdir(curdir);
assignfile(btc,'pack_dir.cmd');
rewrite(btc);
writeln(btc,'@echo off');
writeln(btc,'echo This file generated by UPX - user interface 1.3');
writeln(btc,'echo copying UPX...');
writeln(btc,'copy upx.exe "'+dr+'"');
writeln(btc,'echo Packing...');
writeln(btc,dr[1]+dr[2]);
writeln(btc,'cd "'+dr+'"');
writeln(btc,cmdl.text);
writeln(btc,'del upx.exe');
closefile(btc);
chdir(curdir);
winexec('pack_dir.cmd',sw_Show);
ap:=true;
if (acl.Checked) then close;
end;

function TForm1.mkcmdline():string;
var tst:string;
begin
if (mkbkp.Checked=true) then tst:=' -k';
if (frc.Checked=true) then tst:=tst+' --force';
if cicons.ItemIndex=0 then tst:=tst+' --compress-icons=0';
if cicons.ItemIndex=2 then tst:=tst+' --compress-icons=2';
if (cexp.Checked=false) then tst:=tst+' --compress-exports=0';
if (cres.Checked=false) then tst:=tst+' --compress-resources=0';
if (srel.Checked=false) then tst:=tst+' --strip-relocs=0';
if (ov_lay.ItemIndex=1) then tst:=tst+' --overlay=strip';
if (ov_lay.ItemIndex=2) then tst:=tst+' --overlay=skip';
if r86.Checked then tst:=tst+' --8086';
if no_rel.Checked then tst:=tst+' --no-reloc';
if coff.Checked then tst:=tst+' --coff';
if le.Checked then tst:=tst+' --le';
mkcmdline:=tst;
end;

procedure TForm1.writecmd;
var pt:string;
begin
ap:=false;
if (checkbox1.Checked) then pt:=crindex.Caption else pt:='d';
if (radiobutton1.Checked=true) then begin
cmdl.Text:='UPX -'+pt+mkcmdline+' '+sfile.text;
end else begin
if not getds then
cmdl.Text:='UPX -'+pt+mkcmdline+' '+dir.text+'*.*' else
cmdl.Text:='UPX -'+pt+mkcmdline+' *.*'; end;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
writecmd;
end;

procedure TForm1.cmprateChange(Sender: TObject);
begin
if (cmprate.Position<10) then
crindex.Caption:=inttostr(cmprate.Position) else crindex.Caption:='-best';
writecmd;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
getdir(0,curdir);
if (fileexists('upx.exe')=false) then begin showmessage('UPX.exe -  !');
halt(0); end;
loadcfg;
ap:=false;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
close;
end;

procedure TForm1.Button1Click(Sender: TObject);
var n,x:integer;
s,sa:string;
begin
if (opendialog1.Execute=true) then begin
s:=opendialog1.FileName;
x:=0;
for n:=1 to length(s) do if (s[n]=' ') then x:=1;
if (x=1) then sfile.Text:='"'+s+'"' else sfile.Text:=s;
x:=0;
for n:=length(s) downto 1 do
if (s[n]='\') then begin x:=n; break; end;
for n:=1 to x do sa:=sa+s[n];
dir.Text:=sa;
end; writecmd; end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
if checkbox1.Checked then begin
checkbox1.caption:='';
checkbox1.Hint:='  ';
end else begin
checkbox1.caption:='';
checkbox1.Hint:='  ';
end;
writecmd;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
chdir(curdir);
if getds and radiobutton2.Checked then batchpack else begin
winexec(pchar(cmdl.Text),sw_show);
if (acl.Checked) then close;
end;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
writecmd;
end;

procedure TForm1.sfileChange(Sender: TObject);
begin
writecmd;
end;

procedure TForm1.dirChange(Sender: TObject);
begin
writecmd;
end;

procedure TForm1.ciconsClick(Sender: TObject);
begin
writecmd;
end;

procedure TForm1.cexpClick(Sender: TObject);
begin
writecmd;
end;

procedure TForm1.cresClick(Sender: TObject);
begin
writecmd;
end;

procedure TForm1.srelClick(Sender: TObject);
begin
writecmd;
end;

procedure TForm1.mkbkpClick(Sender: TObject);
begin
writecmd;
end;

function buftostr(buf: array of char; n:integer):string;
var s:string;
m:integer;
begin
s:='';
for m:=0 to n-1 do s:=s+buf[m];
result:=s;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var cff:file;
buf:array [1..4096] of char;
n:smallint;
m:shortint;
s:string;
begin
chdir(curdir); assignfile(cff,'upxi.cfg'); rewrite(cff,1);
buf[1]:='U'; buf[2]:='P'; buf[3]:='X'; buf[4]:='i';
blockwrite(cff,buf,4);
n:=form1.Left; blockwrite(cff,n,2);
n:=form1.Top; blockwrite(cff,n,2);
s:=sfile.Text; n:=length(s);
blockwrite(cff,n,2);
for n:=1 to length(s) do buf[n]:=s[n];
n:=length(s); blockwrite(cff,buf,n);
s:=dir.Text; n:=length(s);
blockwrite(cff,n,2);
for n:=1 to length(s) do buf[n]:=s[n];
n:=length(s); blockwrite(cff,buf,n);
if radiobutton1.Checked then m:=1 else m:=0;
blockwrite(cff,m,1);
m:=cmprate.Position; blockwrite(cff,m,1);
m:=cicons.ItemIndex; blockwrite(cff,m,1);
if cexp.Checked then m:=1 else m:=0; blockwrite(cff,m,1);
if cres.Checked then m:=1 else m:=0; blockwrite(cff,m,1);
if srel.Checked then m:=1 else m:=0; blockwrite(cff,m,1);
if mkbkp.Checked then m:=1 else m:=0; blockwrite(cff,m,1);
if frc.Checked then m:=1 else m:=0; blockwrite(cff,m,1);
m:=ov_lay.ItemIndex; blockwrite(cff,m,1);
if r86.Checked then m:=1 else m:=0; blockwrite(cff,m,1);
if no_rel.Checked then m:=1 else m:=0; blockwrite(cff,m,1);
if coff.Checked then m:=1 else m:=0; blockwrite(cff,m,1);
if le.Checked then m:=1 else m:=0; blockwrite(cff,m,1);
if acl.Checked then m:=1 else m:=0; blockwrite(cff,m,1);
if checkbox1.Checked then m:=1 else m:=0; blockwrite(cff,m,1);
closefile(cff);
end;

procedure TForm1.loadcfg;
var cff:file;
buf: array [1..4096] of char;
s:string;
n:smallint;
m:shortint;
begin
if not fileexists('upxi.cfg') then exit;
assignfile(cff,'upxi.cfg');
reset(cff,1);
blockread(cff,buf,4);
s:=buftostr(buf,4);
if (s<>'UPXi') then begin showmessage('  ! :( '+s); closefile(cff); exit; end;
blockread(cff,n,2); form1.Left:=n;
blockread(cff,n,2); form1.top:=n;
blockread(cff,n,2); blockread(cff,buf,n); sfile.Text:=buftostr(buf,n);
blockread(cff,n,2); blockread(cff,buf,n); dir.Text:=buftostr(buf,n);
blockread(cff,m,1);
if (m=1) then radiobutton1.Checked:=true else radiobutton2.Checked :=true;
blockread(cff,m,1); cmprate.Position:=m;
blockread(cff,m,1); cicons.ItemIndex:=m;
blockread(cff,m,1); if (m=0) then cexp.Checked:=false;
blockread(cff,m,1); if (m=0) then cres.Checked:=false;
blockread(cff,m,1); if (m=0) then srel.Checked:=false;
blockread(cff,m,1); if (m=1) then mkbkp.Checked:=true;
blockread(cff,m,1); if (m=1) then frc.Checked:=true;
blockread(cff,m,1); ov_lay.ItemIndex := m;
blockread(cff,m,1); if (m=1) then r86.Checked:=true;
blockread(cff,m,1); if (m=1) then no_rel.Checked:=true;
blockread(cff,m,1); if (m=1) then coff.Checked:=true;
blockread(cff,m,1); if (m=1) then le.Checked:=true;
blockread(cff,m,1); if (m=0) then acl.Checked:=false;
blockread(cff,m,1); if (m=0) then checkbox1.Checked:=false;
closefile(cff);
end;

procedure TForm1.frcClick(Sender: TObject);
begin
writecmd;
end;

procedure TForm1.cmdlKeyPress(Sender: TObject; var Key: Char);
begin
if (ord(key)=13) then Button2click(Form1);
end;

procedure TForm1.r86Click(Sender: TObject);
begin
writecmd;
end;

procedure TForm1.no_relClick(Sender: TObject);
begin
writecmd;
end;

procedure TForm1.coffClick(Sender: TObject);
begin
writecmd;
end;

procedure TForm1.leClick(Sender: TObject);
begin
writecmd;
end;

procedure TForm1.ov_layChange(Sender: TObject);
begin
writecmd;
end;

procedure TForm1.ciconsChange(Sender: TObject);
begin
writecmd;
end;

end.
